<?php

/**
 * Envia_oauth_connection can have 3 states: wait, true, false
 */
// function envia_shipping_start() {
// var_dump('ingresa');
// wp_enqueue_script( 'test', plugins_url( '../admin/js/test.js', __FILE__ ), array(), '1.0', false );
// add_option( 'envia_oauth_connection', 'false' );
// }
/**
 *   Set a flag value that indicates if the store is connected.
 */
// register_activation_hook( __FILE__, 'envia_shipping_start' );

/**
 *   Condition that evaluates the flag value when the plugin is active.
 */
add_action( 'admin_init', 'load_oauth' );

function load_oauth() {
	if ( is_plugin_active( MAINFILE ) ) {
		if ( ! get_option( 'envia_oauth_connection' ) ) {
			add_option( 'envia_oauth_connection', 'false' );
		}
	};
	$pages_allow_oauth = array(
		'wp-admin/plugins',
		'wp-admin/update.php?action=upload-plugin',
		'wp-admin/admin',
	);
	$self              = isset( $_SERVER['PHP_SELF'] ) ? sanitize_text_field( $_SERVER['PHP_SELF'] ) : null;
	// false is the state for redirect to admin plugin site
	if ( is_admin() && get_option( 'envia_oauth_connection' ) == 'false' ) {
		foreach ( $pages_allow_oauth as $page ) {
			if ( strpos( $self, $page ) ) {
				update_option( 'envia_oauth_connection', 'wait' );
				wp_enqueue_script( 'oauth', plugins_url( '../admin/js/oauth.js', __FILE__ ), array(), '1.1', false );
				wp_localize_script(
					'oauth',
					'oauthData',
					array(
						'status'  => 'false',
						'dirname' => MAINDIR,
					)
				);
			}
		}
	}
	if ( is_admin() && get_option( 'envia_oauth_connection' ) == 'wait' ) {
		if ( strpos( $self, 'wp-admin/admin' ) ) {
			wp_enqueue_script( 'oauth', plugins_url( '../admin/js/oauth.js', __FILE__ ), array(), '1.1', 'wait' );
			wp_localize_script(
				'oauth',
				'oauthData',
				array(
					'status'  => 'wait',
					'dirname' => MAINDIR,
				)
			);
		}
	}
	if ( is_admin() && get_option( 'envia_oauth_connection' ) == 'true' ) {
		if ( strpos( $self, 'wp-admin/admin' ) ) {
			wp_enqueue_script( 'oauth', plugins_url( '../admin/js/oauth.js', __FILE__ ), array(), '1.1', 'false' );
			wp_localize_script(
				'oauth',
				'oauthData',
				array(
					'status'  => 'true',
					'dirname' => MAINDIR,
				)
			);
		}
	}
}


/**
*   Callback of envia connection status
*/
add_action( 'wp_ajax_envia_check', 'catch_envia_status' );

add_action( 'woocommerce_api_envia_shipping', 'catch_envia_status' );

function catch_envia_status() {
	if ( isset( $_GET['status'] ) ) {
			$hash = isset( $_GET['hash'] ) ? sanitize_text_field( $_GET['hash'] ) : null;
		if ( 'active' == $_GET['status'] && ! is_null( $hash ) ) {
			update_option( 'envia_oauth_connection', 'true' );
			$settings = get_option( 'woocommerce_envia_shipping_settings' );
			if ( ! isset( $settings ) ) {
				add_option( 'woocommerce_envia_shipping_settings', array( 'token' => $hash ) );
			} else {
				// if exists but is empty
				if ( is_array( $settings ) ) {
					// if exists element in array but doesn't have value
					 $settings['token'] = $hash;
				} else {
					// if exists but is empty (the value is null and array doesn't exists)
					 $settings = array( 'token' => $hash );
				}
				update_option( 'woocommerce_envia_shipping_settings', $settings );
			}
			header( 'HTTP/1.1 201 OK' );
		} elseif ( 'inactive' == $_GET['status'] ) {
			update_option( 'envia_oauth_connection', 'false' );
			deactivate_plugins( MAINFILE );
			header( 'HTTP/1.1 200 OK' );
		} elseif ( 'check' == $_GET['status'] ) {
			$is_active = get_option( 'envia_oauth_connection' );
			$settings  = get_option( 'woocommerce_envia_shipping_settings' );
			if ( 'true' == $is_active && '' != $settings['token'] ) {
				echo json_encode( array( 'status' => 'success' ) );
				header( 'HTTP/1.1 201 OK' );
			} else {
				if ( 'false' == $is_active ) {
					update_option( 'envia_oauth_connection', 'wait' );
				}
				echo json_encode( array( 'status' => 'fail' ) );
				header( 'HTTP/1.1 400 OK' );
			}
		} elseif ( 'update' == $_GET['status'] ) {
			update_option( 'envia_oauth_connection', 'wait' );
			header( 'HTTP/1.1 200 OK' );
		} else {
			header( 'HTTP/1.1 400 OK' );
		}
	}
	die();
}
// add_filter( 'plugin_action_links_' . plugin_basename( __FILE__ ), 'add_plugin_page_settings_link' );
// function add_plugin_page_settings_link( $links ) {
// $links[] = '<a href="' .
// admin_url( 'options-general.php?page=my-plugin' ) .
// '">' . __( 'Settings' ) . '</a>';
// return $links;
// }

function action_after_shipping_rate( $method, $index ) {
	if ( 'envia_shipping' == $method->method_id ) {
		echo "<div class='rate-content'><div class= 'envia-shipping-complement-div'>" . PHP_EOL;
		echo "<img class= 'envia-shipping-carrier-img' src='https://s3.us-east-2.amazonaws.com/enviapaqueteria/uploads/logos/carriers/" . esc_html( $method->meta_data['carrier'] ) . ".svg'>" . PHP_EOL;
		echo '</div>' . PHP_EOL;
		echo '<p>' . esc_html( $method->meta_data['delivery'] ) . '</p></div>';
	}
	wp_enqueue_script( 'changeLabel', plugins_url( '../public/js/carriersLabel.js', __FILE__ ), array(), '1.0', false );
}


