<?php
	add_filter( 'bulk_actions-edit-shop_order', 'downloads_bulk_actions_edit_product_envia', 20, 1 );
function downloads_bulk_actions_edit_product_envia( $actions ) {
	$actions['write_downloads'] = __( 'Create multiple labels', 'woocommerce' );
	return $actions;
}

	// Make the action from selected orders
	add_filter( 'handle_bulk_actions-edit-shop_order', 'downloads_handle_bulk_action_edit_shop_order_envia', 10, 3 );
function downloads_handle_bulk_action_edit_shop_order_envia( $redirect_to, $action, $post_ids ) {
	if ( 'write_downloads' !== $action ) {
		return $redirect_to; // Exit
	}

	global $attach_download_dir, $attach_download_file; // ???

	$processed_ids = array();

	$site = preg_replace( '(^https?://)', '', get_site_url() );

	$url = ' https://ship.envia.com/integrate/createmultilabel?shop=' . $site;

	foreach ( $post_ids as $post_id ) {
		$url       .= '&ids[]=' . $post_id;
		$order      = wc_get_order( $post_id );
		$order_data = $order->get_data();

		// Your code to be executed on each selected order
		fwrite(
			$myfile,
			$order_data['date_created']->date( 'd/M/Y' ) . '; ' .
			'#' . ( ( $order->get_type() === 'shop_order' ) ? $order->get_id() : $order->get_parent_id() ) . '; ' .
			'#' . $order->get_id()
		);
		$processed_ids[] = $post_id;
	}

	echo '<script type="text/javascript" language="Javascript">window.open("' . esc_js( $url ) . '");</script>';
	die();

	/*
	return $redirect_to = add_query_arg( array(
	'write_downloads' => '1',
	'processed_count' => count( $processed_ids ),
	'processed_ids' => implode( ',', $processed_ids ),
	), $redirect_to );*/
}

	// The results notice from bulk action on orders
	add_action( 'admin_notices', 'downloads_bulk_action_admin_notice_envia' );
function downloads_bulk_action_admin_notice_envia() {
	if ( empty( $_REQUEST['write_downloads'] ) ) {
		return; // Exit
	}

	$count = intval( ( isset( $_REQUEST['processed_count'] ) ? $_REQUEST['processed_count'] : 0 ) );

	printf(
		'<div id="message" class="updated fade"><p>' .
		esc_html(
		/* translators: %s: Number of Orders*/
			_n(
				'Processed %s Order for download.',
				'Processed %s Orders for downloads.',
				$count,
				'write_downloads'
			)
		) . '</p></div>',
		esc_html( $count )
	);
}

	add_action( 'add_meta_boxes', 'my_order_meta_box_envia' );
function my_order_meta_box_envia() {
	add_meta_box(
		'woocommerce-order-enviamodule',
		__( 'Generate New Shipping Label - ENVIA.COM' ),
		'order_meta_box_content_envia',
		'shop_order',
		'side',
		'high'
	);
}

function wp_enqueue_custom_stylesheets() {
	wp_enqueue_style( 'envia_bootstrap_stylesheet', plugins_url( '../admin/css/bootstrap.min.css', __FILE__ ), array(), '1' );
	wp_enqueue_style( 'envia_stylesheet', plugins_url( '../admin/css/woocommerce_module.min.css?3', __FILE__ ), array(), '3' );
}
	add_action( 'envia_styles_hook', 'wp_enqueue_custom_stylesheets' );

function wp_enqueue_custom_scriptsheets() {
	wp_enqueue_script( 'envia_bootstrap_script', plugins_url( '../admin/js/bootstrap.min.js', __FILE__ ), array(), '1' );
	wp_enqueue_script( 'envia_script', plugins_url( '../admin/js/woocommerce_module.min.js?8', __FILE__ ), array(), '6' );
}
	add_action( 'envia_scripts_hook', 'wp_enqueue_custom_scriptsheets' );

function order_meta_box_content_envia() {
	do_action( 'envia_styles_hook' );
	do_action( 'envia_scripts_hook' );
	$url           = get_site_url();
	$id            = isset( $_GET['post'] ) ? sanitize_text_field( $_GET['post'] ) : '';
	$enviaHostname = ENVIA_HOSTNAME;
	$enviaLanding  = ENVIA_LANDING;
	$enviaS3       = ENVIA_S3;
	$order         = get_content( "{$enviaHostname}/integrate/orders?id={$id}&shop={$url}&ecommerce=woocommerce" );
	$o             = json_decode( $order, true );

	echo '
		<input style="display:none;" data-name="enviaJQuery" data-hostname="' . esc_attr( $enviaHostname ) . '" data-shop="' . esc_attr( $url ) . '">
		
		<div id="enviaPrestashopModal" class="modal fade" tabindex="-1" role="dialog">
			<div class="modal-dialog modal-lg" role="document" style="min-width: 85%;left: 3%;">
				<div class="modal-content">
					<div class="modal-body">
						<div id="preloader">
							<div class="preloader-content">
								<div class="preload"></div>
								<img src="' . esc_url( $enviaS3 ) . '/uploads/images/logo-enviapaqueteria.png" alt="">
							</div>
						</div>
						<iframe src="" style="display: block; position: relative; width: 100%; height: 800px;" frameborder="0" id="iframe"></iframe>
					</div>
				</div>
			</div>
		</div>';
	echo '<div id="enviapaqueteria_module">';
	if ( true == $o['success'] && 0 < $o['count'] ) {
		echo '
			<div style="text-align:center;padding: 15px 0px;">
				<p style="margin: 0;padding-top:5px;" class="alert-success">Guía Generada con Éxito</p>
				<h2 style="margin-top: 0;padding: 0;font-size: 20px;padding-bottom:5px;font-weight:bolder;" class="alert-success"><a href="{$enviaLanding}/rastreo?label=' . esc_url( $o['data']['tracking_number'] ) . '" class="text-success" target="_blank">' . esc_html( $o['data']['tracking_number'] ) . '</a></h2>
				<p style="margin:0;margin-top:10px;"><strong>Creada:</strong> ' . esc_html( strftime( '%d %b, %Y', strtotime( $o['data']['created_at'] ) ) ) . '</p>
				<p style="margin:0; text-transform: capitalize;"><strong>Paquetería:</strong> ' . esc_html( $o['data']['carrier'] ) . '</p>
				<p style="margin:0; text-transform: capitalize;"><strong>Tipo:</strong> ' . esc_html( $o['data']['service_type'] ) . '</p>
			</div>
			<div class="wide">
				<div id="delete-action">
					<a class="btn btn-default" target="_blank" href="' . esc_url( $enviaS3 ) . '/uploads/' . esc_url( $o['data']['carrier_id'] ) . '/' . esc_url( $o['data']['file'] ) . '">Descargar Guía</a>
				</div>
				<a href="{$enviaLanding}/rastreo?label=' . esc_url( $o['data']['tracking_number'] ) . '" target="_blank" type="submit" class="button save_order button-primary">Rastrea tu Guía</a>
			</div>
			';
	} else {
		echo '
			<button type="button" class="btn btn-default enviaBtn" data-id="' . esc_attr( $id ) . '" data-shop="' . esc_attr( $url ) . '" data-type="">
				<span class="img"><img src="' . esc_url( $enviaS3 ) . '/uploads/images/logo-enviapaqueteria.png" alt="" width="40"></span>
				<span>Quote Shipping</span>
			</button>
			<button type="button" class="btn btn-default enviaBtn" data-id="' . esc_attr( $id ) . '" data-shop="' . esc_attr( $url ) . '" data-type="true">
				<span class="img"><img src="' . esc_url( $enviaS3 ) . '/uploads/images/logo-enviapaqueteria.png" alt="" width="40"></span>
				<span>Generate Shipping</span>
			</button>';
	}
	echo '</div>';
}

	add_action( 'woocommerce_admin_order_data_after_order_details', 'fulfillment_display_order_data_envia' );
function fulfillment_display_order_data_envia( $order ) {
	if ( get_post_meta( $order->get_id(), '_carrier', true ) && get_post_meta( $order->get_id(), '_tracking_url', true ) ) { ?>
			<div class="order_data_column" style='width:100%'>
				<h3><?php esc_html_e( 'Fulfillment' ); ?></h3>
				<div>
					<?php
					echo '<p><strong>' . esc_html_e( 'Carrier' ) . ':</strong></br>';
					echo esc_html( get_post_meta( $order->get_id(), '_carrier', true ) ) . '</p>';

					echo '<p><strong>' . esc_html_e( 'Tracking number' ) . ':</strong></br>';
					echo '<a target="blank" href="' . esc_html( get_post_meta( $order->get_id(), '_tracking_url', true ) ) . '">' . esc_html( get_post_meta( $order->get_id(), '_tracking_number', true ) ) . '</a></p>';
					echo '<p><strong>' . esc_html_e( 'Fulfilled by' ) . ':</strong></br>';
					echo esc_html_e( get_post_meta( $order->get_id(), '_fulfilled_by', true ) ) . '</p>';
					?>
				</div>
			</div>
			<?php
	}
}

	add_action( 'woocommerce_checkout_order_processed', 'copy_product_input_fields_to_order_meta_envia', PHP_INT_MAX );
function copy_product_input_fields_to_order_meta_envia( $order_id ) {
	$fields_to_update = array(
		'_wcj_product_input_fields_global_1',
		'_wcj_product_input_fields_local_1',
	);
	foreach ( $fields_to_update as $field_to_update ) {
		update_post_meta(
			$order_id,
			$field_to_update,
			do_shortcode( '[wcj_order_items_meta order_id="' . $order_id . '" meta_key="' . $field_to_update . '"]' )
		);
	}
}

function get_content( $URL ) {
	$ch = curl_init();
	curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 );
	curl_setopt( $ch, CURLOPT_URL, $URL );
	$data = curl_exec( $ch );
	curl_close( $ch );
	return $data;
}
